%modal2 (form b)

function[r,am,bm,cm] = modal2b(a,b,c)

[v,an]=eig(a);

bn=inv(v)*b;
cn=c*v;

i=find(imag(diag(an))');
index=i(1:2:length(i));
j=sqrt(-1);
t=eye(length(an));

if isempty(index)
    am=an;bm=bn;cm=cn;
else
    for i=index
        t(i:i+1,i:i+1)=[j 1; -j 1];
        z(i)=-real(an(i,i))/abs(an(i,i));
    end
    % modal form 2
    am= real(inv(t)*an*t);
    bm=real(inv(t)*bn);
    cm=real(cn*t);
    
    % correcting for nonzero terms by another transformation
    % nonzero terms may appear in bm since the modal representation
    % with block diagonal am is not unique
    % so we need to find a transformation that does not alter am,
    % but should correct the nonzero terms in bm.
    % the following works for modal form 1, but needs to be modified for
    % form 2
    beta=1;
    for i=index
        alpha=-beta*bm(i+1,1)/bm(i);
        s(i,i)=alpha+2*z(i)*beta;
        s(i,i+1)=beta;
        s(i+1,i)=-beta;
        s(i+1,i+1)=alpha;
    end
    am=inv(s)*am*s;
    bm=inv(s)*bm;
    cm=cm*s;
    
    r=v*t*s; % transformation matrix
end
